package de.hdm_stuttgart.mi.sda1;

import de.hdm_stuttgart.mi.sda1.model.StudyCourse;
import de.hdm_stuttgart.mi.sda1.model.StudyCourse_;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;
import java.util.List;

/**
 * Read {@link StudyCourse} instances by criteria query.
 */
public class CriteriumReadLikeC_courses {

  static private final EntityManagerFactory factory = Persistence.createEntityManagerFactory(
    "strategy_none");

  static private final EntityManager entityManager = factory.createEntityManager();

  static private final CriteriaBuilder builder = factory.getCriteriaBuilder();
  /**
   * @param args unused
   */
  public static void main( String[] args ) {

    final CriteriaQuery<StudyCourse> criteria = builder.createQuery(StudyCourse.class);
    final Root<StudyCourse> studyCourseRoot = criteria.from(StudyCourse.class);
    criteria.select( studyCourseRoot );
    criteria.where( builder.like( studyCourseRoot.get(StudyCourse_.shortName), "C%" ) );
    final List<StudyCourse> studyCourses = entityManager.createQuery( criteria ).getResultList();

    studyCourses.stream().map(s -> "Read '" + s + "'").forEach(System.out::println);

    factory.close();
  }
}