package de.hdm_stuttgart.mi.sda1;

import de.hdm_stuttgart.mi.sda1.model.StudyCourse;
import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;

/**
 * Read a {@link StudyCourse} by its primary key value.
 */
public class JpqlReadAllStudyCourses {

  static private final Logger log = LogManager.getLogger(JpqlReadAllStudyCourses.class);

  static private final EntityManagerFactory factory = Persistence.createEntityManagerFactory(
    "strategy_none");

  static private final EntityManager entityManager = factory.createEntityManager();
  /**
   * @param args unused
   */
  public static void main( String[] args ) {

    {
      log.info("Straight JPQL");
      final Query query = entityManager.createQuery(
        "SELECT S FROM StudyCourse AS S WHERE S.shortName like 'C%'");

      query.getResultList().
        stream().map(s -> "Read '" + s + "'").forEach(System.out::println);
    }
    {
      log.info("JPQL using parameter");
      final Query query = entityManager.createQuery(
        "SELECT S FROM StudyCourse AS S WHERE S.shortName like :pattern");
      query.setParameter("pattern", "C%");

      query.getResultList().
        stream().
        map(s -> "Read '" + s + "'").
        forEach(System.out::println);
    }


    factory.close();
  }
}