package de.hdm_stuttgart.mi.sd1.test.aufgabe1;

import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.aufgabe1.InternetShop;

/**
 * Testen von Hilfsmethoden aus der Klasse {@link InternetShop}.
 *
 */
@SuppressWarnings({"static-method"})
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_InternetShop extends ExaminationTestDefaults {

   /**
    * Toleranz bei Rundungsfehlern in double Vergleichen. Erläuterung
    * siehe z.B. {@link Assert#assertEquals(double, double, double)}.
    */
   static public final double testDelta = 1.E-10; 
   
   /**
    * Mit Rabatt, ohne Versandkosten.
    */
   @Test
   @Marking(points=2)
   public void test_10_rabattKeineVersandkosten() {
      final double wert=400;
      Assert.assertEquals(wert * (100 - InternetShop.PROZENTUALER_RABATT) / 100, InternetShop.getGesamtpreis(400), testDelta);
   }

   /**
    * Ohne Rabatt, ohne Versandkosten
    */
   @Test
   @Marking(points=3)
   public void test_11_keinRabattKeineVersandkosten() {
      final double wert = 200;
      Assert.assertEquals(wert, InternetShop.getGesamtpreis(wert), testDelta);
   }

   /**
    * Ohne Rabatt, mit Versandkosten
    */
   @Test
   @Marking(points=3)
   public void test_12_keinRabattMitVersandkosten() {
      final double wert = 80;
      Assert.assertEquals(wert + InternetShop.VERSANDKOSTEN, InternetShop.getGesamtpreis(wert), testDelta);
   }
}