package de.hdm_stuttgart.mi.sd1.test.aufgabe1;

import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.aufgabe1.HandyAbrechnung;

/**
 * <p>Testen des Auftretens eines Teil-String in einem vorgegebenen String.</p>
 *
 */
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_HandyAbrechnung extends ExaminationTestDefaults {
   
   /**
    * Nur Inland, in Freigrenze
    */
   @Test
   @Marking(points=1)
   public void test_200() {
      Assert.assertEquals(0,  HandyAbrechnung.getMonatskosten(0, 0));
      Assert.assertEquals(0,  HandyAbrechnung.getMonatskosten(99, 0));
      Assert.assertEquals(0,  HandyAbrechnung.getMonatskosten(100, 0));
   }

   /**
    * nur Inland, Über Freigrenze
    */
   @Test
   @Marking(points=2)
   public void test_220() {
      
      Assert.assertEquals(HandyAbrechnung.inlandPreisProMinute,  HandyAbrechnung.getMonatskosten(101, 0));
      Assert.assertEquals(7 * HandyAbrechnung.inlandPreisProMinute,  HandyAbrechnung.getMonatskosten(107, 0));
      Assert.assertEquals(123 * HandyAbrechnung.inlandPreisProMinute,  HandyAbrechnung.getMonatskosten(223, 0));
   }

   /**
    * Nur Ausland
    */
   @Test
   @Marking(points=2)
   public void test_240() {
      Assert.assertEquals(HandyAbrechnung.auslandPreisProMinute,  HandyAbrechnung.getMonatskosten(0, 1));
      Assert.assertEquals(22 * HandyAbrechnung.auslandPreisProMinute,  HandyAbrechnung.getMonatskosten(0, 22));
   }

   /**
    * Kombiniert Inland unter Freigrenze + Ausland
    */
   @Test
   @Marking(points=2)
   public void test_260() {
      Assert.assertEquals(14 * HandyAbrechnung.auslandPreisProMinute,  HandyAbrechnung.getMonatskosten(99, 14));
      Assert.assertEquals(15 * HandyAbrechnung.auslandPreisProMinute,  HandyAbrechnung.getMonatskosten(100, 15));
   }

   /**
    * Kombiniert Inland über Freigrenze + Ausland
    */
   @Test
   @Marking(points=3)
   public void test_280() {
      Assert.assertEquals(
            HandyAbrechnung.inlandPreisProMinute + 14 * HandyAbrechnung.auslandPreisProMinute,
            HandyAbrechnung.getMonatskosten(101, 14));

      Assert.assertEquals(
            125 * HandyAbrechnung.inlandPreisProMinute + 23 * HandyAbrechnung.auslandPreisProMinute,
            HandyAbrechnung.getMonatskosten(225, 23));
   }
}