package de.hdm_stuttgart.mi.sd1.test.aufgabe1;

import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.aufgabe1.Helper;


/**************************
 * Abschnitt maxVorgaenger *
 **************************/

/**
 * <p>Testen des Auftretens eines Teil-Strings in einem vorgegebenen String.</p>
 *
 */
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_Helper extends ExaminationTestDefaults {

   /************************
    * Abschnitt getSuperToll*
    ************************/

   /**
    * Weder noch.
    */
   @Test
   @Marking(points=3)
   public void test_080() {
      Assert.assertEquals("2", Helper.getSuperToll(2));
      Assert.assertEquals("7", Helper.getSuperToll(7));
   }

   /**
    * Nur durch 3, aber nicht durch 5 teilbar
    */
   @Test
   @Marking(points=3)
   public void test_090() {
      Assert.assertEquals("Toll", Helper.getSuperToll(3));
      Assert.assertEquals("Toll", Helper.getSuperToll(6));
      Assert.assertEquals("Toll", Helper.getSuperToll(9));
      Assert.assertEquals("Toll", Helper.getSuperToll(18));
      Assert.assertEquals("Toll", Helper.getSuperToll(21));
   }

   /**
    * Nur durch 5, aber nicht durch 3 teilbar.
    */
   @Test
   @Marking(points=3)
   public void test_100() {
      Assert.assertEquals("Super", Helper.getSuperToll(5));
      Assert.assertEquals("Super", Helper.getSuperToll(10));
      Assert.assertEquals("Super", Helper.getSuperToll(20));
      Assert.assertEquals("Super", Helper.getSuperToll(35));
      Assert.assertEquals("Super", Helper.getSuperToll(40));
   }

   /**
    * Sowohl durch 3 als auch durch 5 teilbar
    */
   @Test
   @Marking(points=3)
   public void test_110() {
      Assert.assertEquals("Supertoll", Helper.getSuperToll(0));
      Assert.assertEquals("Supertoll", Helper.getSuperToll(15));
      Assert.assertEquals("Supertoll", Helper.getSuperToll(45));
   }   


   /***************************
    * Abschnitt maxVorgaenger *
    **************************/

   /**
    * maxVorgaenger(null).
    */
   @Test
   @Marking(points=1)
   public void test_120() {
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.maxVorgaenger(null));
   }

   /**
    * maxVorgaenger Array mit weniger als zwei Werten.
    */
   @Test
   @Marking(points=1)
   public void test_140() {
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.maxVorgaenger(new int[]{     }));
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.maxVorgaenger(new int[]{ 554 }));
   }

   /**
    * maxVorgaenger Zwei Werte, ohne Erfolg.
    */
   @Test
   @Marking(points=2)
   public void test_160() {
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.maxVorgaenger(new int[]{ 2,  2 }));
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.maxVorgaenger(new int[]{ 3,  2 }));
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.maxVorgaenger(new int[]{ 0,  0 }));
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.maxVorgaenger(new int[]{-3, -3 }));
   }

   /**
    * maxVorgaenger Zwei Werte, mit Erfolg.
    */
   @Test
   @Marking(points=2)
   public void test_180() {
      Assert.assertEquals(1, Helper.maxVorgaenger(new int[]{   0,   1 }));
      Assert.assertEquals(1, Helper.maxVorgaenger(new int[]{   0,   3 }));
      Assert.assertEquals(1, Helper.maxVorgaenger(new int[]{ -10,  -9 }));
      Assert.assertEquals(1, Helper.maxVorgaenger(new int[]{ -10,  10 }));
      Assert.assertEquals(1, Helper.maxVorgaenger(new int[]{ 223, 225 }));
   }

   /**
    * Mehrere Werte, kein Erfolg
    */
   @Test
   @Marking(points=2)
   public void test_200() {
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.maxVorgaenger(new int[]{  2,  1,   3,  -2, 2, 6, 1 }));
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.maxVorgaenger(new int[]{ -5, -7, -12, -25 }));
   }

   /**
    * Mehrere Werte, Erfolg
    */
   @Test
   @Marking(points=2)
   public void test_220() {
      Assert.assertEquals(5, Helper.maxVorgaenger(new int[]{ 2,  -1,  0,  1,  2, 5, 4, 40 }));
      Assert.assertEquals(3, Helper.maxVorgaenger(new int[]{ 0,  -1, -2, -2,  2, 6, 1 }));
      Assert.assertEquals(3, Helper.maxVorgaenger(new int[]{ 0,   0,  0,  1, 20 }));
   }

   /************************************
    * Abschnitt getNtesUngeradesElement *
    ************************************/

   /**
    * Leer
    */
   @Test
   @Marking(points=1)
   public void test_300() {
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.getNtesUngeradesElement(new int[]{}, 1));
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.getNtesUngeradesElement(new int[]{}, 4));
   }

   /**
    * Ein Element, negativ 
    */
   @Test
   @Marking(points=1)
   public void test_320() {
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.getNtesUngeradesElement(new int[]{6}, 1));
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.getNtesUngeradesElement(new int[]{6}, 1));
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.getNtesUngeradesElement(new int[]{1}, 2));
   }

   /**
    * Ein Element, positiv
    */
   @Test
   @Marking(points=1)
   public void test_340() {
      Assert.assertEquals(0, Helper.getNtesUngeradesElement(new int[]{1}, 1));
   }

   /**
    * Zwei Elemente, negativ 
    */
   @Test
   @Marking(points=1)
   public void test_30() {
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.getNtesUngeradesElement(new int[]{8, 2}, 1));
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.getNtesUngeradesElement(new int[]{8, 2}, 2));
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.getNtesUngeradesElement(new int[]{1, 4}, 2));
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.getNtesUngeradesElement(new int[]{1, 5}, 3));
   }

   /**
    * Zwei Elemente, positiv
    */
   @Test
   @Marking(points=2)
   public void test_360() {
      Assert.assertEquals(0, Helper.getNtesUngeradesElement(new int[]{1, 2}, 1));
      Assert.assertEquals(1, Helper.getNtesUngeradesElement(new int[]{1, 1}, 2));
   }

   /**
    * Mehrere Elemente, negativ
    */
   @Test
   @Marking(points=1)
   public void test_380() {
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.getNtesUngeradesElement(new int[]{-4,  6,  0, -2,   8}, 1));
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.getNtesUngeradesElement(new int[]{-4,  6,  0, -2,   8}, 2));
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.getNtesUngeradesElement(new int[]{ 1,  3, -2,  5, -11}, 5));
      Assert.assertEquals(Helper.INDEX_NOEXIST, Helper.getNtesUngeradesElement(new int[]{ 1,  3, -2,  5, -11}, 20));
   }

   /**
    * Mehrere Elemente, positiv
    */
   @Test
   @Marking(points=1)
   public void test_400() {
      Assert.assertEquals(2, Helper.getNtesUngeradesElement(new int[]{-4,  6,  1, -2,   8}, 1));
      Assert.assertEquals(4, Helper.getNtesUngeradesElement(new int[]{-4,  6,  1, -2,   3}, 2));
      Assert.assertEquals(0, Helper.getNtesUngeradesElement(new int[]{-3,  6,  1, -2,   3}, 1));
   }   
}