DROP TABLE IF EXISTS Translation;
DROP TABLE IF EXISTS Noun; 
DROP TABLE IF EXISTS Language; 

CREATE TABLE  Language (
  id INTEGER AUTO_INCREMENT PRIMARY KEY,
  lang CHAR(2) NOT NULL UNIQUE
);

CREATE TABLE Noun (
    id INTEGER AUTO_INCREMENT PRIMARY KEY,
    lang INTEGER NOT NULL,
    word CHAR(255) NOT NULL,
    UNIQUE(lang, word),
    FOREIGN KEY (lang) REFERENCES Language(id)
);

CREATE TABLE Translation(
   fromNoun INTEGER,
   toNoun INTEGER,
   PRIMARY KEY(fromNoun, toNoun),
   FOREIGN KEY (fromNoun) REFERENCES Noun(id),
   FOREIGN KEY (toNoun) REFERENCES Noun(id)
);


SELECT * FROM Translation;
SELECT * FROM Noun;
SELECT * FROM Language;

SELECT f.word, fLang.lang, t.word, toLang.lang
FROM Language fLang, Noun f, Translation trans, Noun t, Language toLang
WHERE fLang.id = f.lang
  AND f.id = trans.fromNoun
  AND trans.toNoun = t.id
  AND t.lang=toLang.id;

DELETE FROM Translation;
DELETE FROM Noun;
DELETE FROM Language;
