DROP TABLE IF EXISTS ActorMovie;
DROP TABLE IF EXISTS Movie;
DROP TABLE IF EXISTS Person;

CREATE TABLE  Person (
   id CHAR(255) PRIMARY KEY
  ,name CHAR(255) NOT NULL
  ,birthYear INT NOT NULL
  ,img CHAR(255) NULL
  ,biography TEXT NULL
);

CREATE TABLE Movie (
   id INTEGER PRIMARY KEY
   
  ,director CHAR(255) NOT NULL
  ,FOREIGN KEY(director) REFERENCES Person(id)
  
  ,title CHAR(255) NOT NULL
  ,year INT NOT NULL
  ,rating DECIMAL(3.1) NOT NULL
);

CREATE TABLE Cast (

     isStar BOOLEAN NULL

	,actor CHAR(255) NOT NULL
	,FOREIGN KEY(actor) REFERENCES Person(id)

	,movie INTEGER NOT NULL
	,FOREIGN KEY(movie) REFERENCES Movie(id)
	,PRIMARY KEY(actor, movie)
);

-- Actors / directors
INSERT INTO Person (id, name, birthYear) VALUES ('rAltmann', 'Robert Altman', 1925);
INSERT INTO Person (id, name, birthYear) VALUES ('aMacDowell', 'Andie MacDowell', 1958);
INSERT INTO Person (id, name, birthYear, img) VALUES ('sKubrick', 'Stanley Kubrick', 1928, 'kubrick.jpg');
INSERT INTO Person (id, name, birthYear, biography) 
  VALUES ('mModine', 'Matthew Modine', 1959, 'The youngest of seven, Matthew was born ...');
INSERT INTO Person (id, name, birthYear) VALUES ('rLeeEremy', 'R. Lee Ermey', 1944);

-- Movies
INSERT INTO Movie VALUES (18113, 'sKubrick', 'Full Metal Jacket', 1987, 8.3);
INSERT INTO Movie VALUES (4342,  'rAltmann', 'Short Cuts',        1993, 7.7);

--Casts --
INSERT INTO Cast                VALUES (true, 'mModine',   18113);
INSERT INTO Cast (actor, movie) VALUES (      'rLeeEremy', 18113);

INSERT INTO Cast (actor, movie) VALUES (       'aMacDowell', 4342);
INSERT INTO Cast                VALUES (false, 'mModine',    4342);


DELETE FROM ;
