package de.hdm_stuttgart.mi.sda1.exam.movie_by_actor;


import java.util.List;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.jdom2.Document;
import org.jdom2.Element;
import org.jdom2.filter.Filters;
import org.jdom2.xpath.XPathExpression;
import org.jdom2.xpath.XPathFactory;

import de.hdm_stuttgart.mi.unitmarking.jdom.DomFilter;

public class Moviedb2MovieByActor implements DomFilter {
	
	final Logger log = LogManager.getLogger(Moviedb2MovieByActor.class);
	
	Element movieDb;
	
	@Override
	public Document process(final Document input) {
		
		final Element html = new Element("html");
		final Document htmlDoc = new Document(html);
		
		final Element body = new Element("body");
		html.addContent(body);
		
		final Element dl = new Element("dl");
		body.addContent(new Element("h1")
				.addContent("List of actors among with their corresponding films"))
				.addContent(dl);
		
		movieDb = input.getRootElement();
		
		movieDb.getChild("persons").getChildren().stream().forEach(
				p -> addFilmsToActor(dl, p)
				);
		
		return htmlDoc;
	}
	
	void addFilmsToActor(final Element dl, final Element person) {
		
		final String movies2actorId = "movie[cast/actor[@ref='" 
		+ person.getAttributeValue("id") +"']]";

		final XPathExpression<Element> xpath =
			    XPathFactory.instance().compile(movies2actorId, Filters.element());
		
		final List<Element> titles = xpath.evaluate(movieDb.getChild("movies"));
		
		if (0 < titles.size()) {
			final Element dt = new Element("dt"),
					dd = new Element("dd");
			
			dl.addContent(dt).addContent(dd);
			dt.addContent(person.getChild("name").getText());
			
			titles.stream()
			.map(t -> t.getChild("title").getText())
			.forEach(s -> {
				dd.addContent(new Element("p").addContent(s));
			});
		}
	}

}
