package de.hdm_stuttgart.mi.sd1.address;

import javafx.application.Application;
import javafx.scene.layout.StackPane;
import javafx.stage.Stage;

public class Main extends Application {

	final StackPane root;

	final LoginScene loginScene;
	
	public final AddressListScene browseAddresses;
	public final NewAddressScene newAddress;
	
	Stage primaryStage;
	
	public Main() {
		root = new StackPane();
		
    	loginScene = new LoginScene(this);
    	newAddress = new NewAddressScene(this);
    	
    	browseAddresses = new AddressListScene(this);
    	browseAddresses.getStylesheets().add(getClass().getResource("styles.css").toExternalForm());
    	
	}
	
    @Override
    public void start(final Stage primaryStage) {
    	this.primaryStage = primaryStage;

        primaryStage.setTitle("Adressverwaltung");
        primaryStage.setScene(loginScene);
        primaryStage.show();
        
    }

    /**
     * The main() method is ignored in correctly deployed JavaFX application.
     * main() serves only as fallback in case the application can not be
     * launched through deployment artifacts, e.g., in IDEs with limited FX
     * support. NetBeans ignores main().
     *
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }
    
    
    public void showAddresses() {
    	primaryStage.setScene(browseAddresses);
    	primaryStage.sizeToScene();
    	primaryStage.show();
    	
    }
    public void addAddress() {
    	primaryStage.setScene(newAddress);
    	primaryStage.sizeToScene();
    	primaryStage.show();
    	
    }
}