package de.hdm_stuttgart.mi.sd1;

import de.hdm_stuttgart.mi.sd1.array.MyArray;
import org.junit.Assert;
import org.junit.Test;

import java.util.Arrays;

public class DistinctTest {

  @Test
  public void testUnique() {
    unique(new int[]{});
    unique(new int[]{-11});
    unique(new int[]{1, 4});
    unique(new int[]{6, 1, 4});
    unique(new int[]{12, 6, 1, 4});
    unique(new int[]{-99, 4, 333, 17, 0, 3, 55});
  }
  @Test
  public void testTwoDuplicate() {
    Assert.assertArrayEquals(new int[]{6}, MyArray.distinct(new int[]{6, 6}));
  }
  @Test
  public void testThreeDuplicate() {
    Assert.assertArrayEquals(new int[]{-1, 6}, MyArray.distinct(new int[]{-1, 6, 6}));
    Assert.assertArrayEquals(new int[]{-1, 6}, MyArray.distinct(new int[]{6, -1, 6}));
    Assert.assertArrayEquals(new int[]{-1, 6}, MyArray.distinct(new int[]{6, 6, -1}));
  }
  @Test
  public void testFourDuplicate() {
    Assert.assertArrayEquals(new int[]{-1, 3, 6}, MyArray.distinct(new int[]{-1, 6, 6, 3}));
    Assert.assertArrayEquals(new int[]{-1, 3, 6}, MyArray.distinct(new int[]{3, 6, -1, 6}));
    Assert.assertArrayEquals(new int[]{-1, 3, 6}, MyArray.distinct(new int[]{6, 6, 3, -1}));

    Assert.assertArrayEquals(new int[]{1, 6}, MyArray.distinct(new int[]{1, 6, 1, 6}));
    Assert.assertArrayEquals(new int[]{1, 6}, MyArray.distinct(new int[]{1, 6, 1, 6, 6, 6, 1 ,1, 6}));
  }
  static void unique(final int[] values) {
    final int[] sortedValues = Arrays.copyOf(values, values.length);
    Arrays.sort(sortedValues);
    Assert.assertArrayEquals(sortedValues, MyArray.distinct(values));
  }
}
