package de.hdm_stuttgart.mi.sd1.collection;

/**
 * Representing Cartesian coordinate values.
 *
 */
public class Coordinate {

  private int x, y;

  /**
   * Create a Cartesian coordinate / point. 
   * @param x X-coordinate value
   * @param y Y-coordinate value
   */
  public Coordinate(int x, int y) {
    this.x = x;
    this.y = y;
  }

  @Override
  public boolean equals(Object obj) {
    if (obj instanceof Coordinate) {
      return x == ((Coordinate)obj).x &&
          y == ((Coordinate)obj).y;
    } else {
      return false;
    }
  }

  @Override
  public String toString() {
    return "(" + x + "|" + y + ")";
  }

  @Override
  public int hashCode() {
    // See last answer (06/16/2014) in
    // http://stackoverflow.com/questions/16629893/good-hashcode-implementation
    return Long.valueOf(x * 31 + y).hashCode();
  }
}
