package de.hdm_stuttgart.mi.sd1;

import org.junit.Assert;
import org.junit.Test;

/**
 * Unit test for simple Mask.
 */
public class MaskTest {
    /**
     * null input
     */
    @Test
    public void testNullInput() {
        Assert.assertEquals( null, Mask.mask(null) );
    }

    /**
     * 4 or less characters should be left untouched.
     */
    @Test
    public void testBelowLimit() {
        Assert.assertEquals( "", Mask.mask("") );
        Assert.assertEquals( "1", Mask.mask("1") );
        Assert.assertEquals( "12", Mask.mask("12") );
        Assert.assertEquals( "123", Mask.mask("123") );
        Assert.assertEquals( "1234", Mask.mask("1234") );
    }
    /**
     * More than 4 characters require masking.
     */
    @Test
    public void testAboveLimit() {
        Assert.assertEquals( "#2345",     Mask.mask("12345") );
        Assert.assertEquals( "##3456",    Mask.mask("123456") );
        Assert.assertEquals( "###4567",   Mask.mask("1234567") );
        Assert.assertEquals( "####5678",  Mask.mask("12345678") );
        Assert.assertEquals( "#####6789", Mask.mask("123456789") );
    }
}