package de.hdm_stuttgart.mi.sd1.shape.model;

/**
 *
 */
public class Circle extends Shape {

   private double radius;
   
   /**
    * Extending {@link Shape#Shape(double, double)} by adding parameter radius
    * on top of center coordinates.
    *
    * @param x First center coordinate component
    * @param y Second center coordinate component
    * @param radius The circle's radius
    */
   public Circle(final double x, final double y, final double radius) {
      super(x, y);
      setRadius(radius);
   }

   @Override
   public String toString() {
      return "Circle " + super.toString() + ", radius=" + radius;
   }

   @Override
   public Shape scale(final double factor) {
      radius *= factor;
      return this;
   }
   public double getArea() {
     return radius * radius * Math.PI;
   }

   public double getPerimeter() {
     return 2 * Math.PI * radius;
   }

   // Getter and setter methods for private attribute
   public double getRadius() { return radius;}
   public void setRadius(final double radius) { this.radius = radius;}
}
