package de.hdm_stuttgart.mi.sd1.htmlformat;

import java.io.FileNotFoundException;
import java.io.IOException;

/**
 * Format address data as ordinary text
 *
 */
public class Address2text {

  /**
   * @param args unused
   */
  public static void main(String[] args) {
    final String addressFileName = "addresses.txt";
    try {
      final AddressDataHandler addresses = new AddressDataHandler(addressFileName);
      
      addresses.printAddresses(System.out, new Address2textFormatter());
    } catch (FileNotFoundException e) {
      System.err.println("File '" + addressFileName + "' not found");
    } catch (IOException e){
      System.err.println("Unable to read from file '" + addressFileName + "'");
    } catch (AddressParseError e) {
      System.err.println("Error in file '" + addressFileName + "' at line " + e.getErrorOffset() + ":"
          + e.getMessage());
    }
  }
}
