package de.hdm_stuttgart.mi.sd1.htmlformat;

import java.io.PrintStream;

/**
 * Formatting {@link Address} records 
 *
 */
public class Address2htmlFormatter implements AddressFormatter {

  public void printHead (PrintStream out) {
    
    out.println("<html xmlns='http://www.w3.org/1999/xhtml'>");
    out.println("  <head>");
    out.println("    <title>Address list:</title>");
    out.println("  </head>");
    out.println("  <body>");
    out.println("    <h1>Address list:</h1>");
    out.println("    <table border='1'>");
    out.println("      <colgroup style='width: 20%'/>");
    out.println("      <colgroup style='width: 30%'/>");
    out.println("      <colgroup style='width: 25%'/>");
    out.println("      <colgroup style='width: 25%'/>");
    out.println("      <tr>");
    out.println("        <th>Name</th>");
    out.println("        <th>Address</th>");
    out.println("        <th>Phone</th>");
    out.println("        <th>E-Mail</th>");
    out.println("      </tr>");
  }
  public void printRecord(Address address, PrintStream out) {

    out.println("      <tr>");
    out.println("        <td>" + wrap(address.firstName) + " " + wrap("b", address.lastName) + "</td>");
    out.println("        <td>" + wrap(address.address + ", " + address.city) + ", " + 
                                 wrap("b", address.postal) + "</td>");
    out.println("        " + wrap("td",address.phone1));
    out.println("        " + wrap("td", address.email));
    out.println("      </tr>");
  }
  public void printTail (PrintStream out) {
    out.println("    </table>");
    out.println("  </body>");
    out.println("</html>");
  }
  
  private static String wrap(final String htmlTag, final String s) {
    
    return "<" + htmlTag + ">" + wrap(s) + "</" + htmlTag + ">";
  }
  
  private static String wrap(final String s) {
    if (s.contains("<") || s.contains(">") || s.contains("&")) {
      return "<![CDATA[" + s + "]]>";
    } else {
      return s;
    }
  }
}