package de.hdm_stuttgart.mi.sd1.grep;

import java.io.IOException;

public class LineProcessor {

	private final LineFilter lineFilter;

	public LineProcessor(final LineFilter lineFilter) {
		this.lineFilter = lineFilter;
	}

	public void process(final Grep.StreamAndMeta[] sources) throws IOException {
		
		for (final Grep.StreamAndMeta source: sources) {
			
			final String prefix = 1 == sources.length ? "" : source.streamName + ":";
			
			for (String inputLine = source.reader.readLine();
					null != inputLine;
					inputLine= source.reader.readLine()) {
				lineFilter.acceptAndPrint(inputLine, prefix);
			}
		}		
	}
	public void findSingleMatch(final Grep.StreamAndMeta[] sources) 
			throws IOException {

		for (final Grep.StreamAndMeta source: sources) {
			for (String inputLine= source.reader.readLine();
					null != inputLine;
					inputLine= source.reader.readLine()) {
				if (lineFilter.accept(inputLine)) {
					System.out.println(source.streamName);
					break;
				}
			}
		}
	}
}
