package de.hdm_stuttgart.mi.sd1.connectfour;

import org.junit.Assert;
import org.junit.Test;

import de.hdm_stuttgart.mi.sd1.tictactoe.Board;

/**
 * Testing Tic-tac-toe.
 */
public class AppTest {
  
    @Test
    public void testDraw() {
      // Creating O|X|O
      //          -+-+-
      //          X|O|O 
      //          -+-+-  
      //          X|O|X
      
      final Board board = new Board(Board.Player.JUNE);
      
      board.nextMove(1);
      board.nextMove(2);
      board.nextMove(3);
      board.nextMove(4);
      board.nextMove(5);
      board.nextMove(7);
      board.nextMove(6);
      board.nextMove(9);
      
      Assert.assertEquals(false, board.allMovesFinished());
      Assert.assertNull(board.evaluateWinner());
      
      board.nextMove(8);
      Assert.assertEquals(true, board.allMovesFinished());
      Assert.assertNull(board.evaluateWinner());
    }

    @Test
    public void testWinner() {
      // Creating O| |x
      //          -+-+-
      //           |O| 
      //          -+-+-  
      //          x| |O
      
      final Board board = new Board(Board.Player.JUNE);

      board.nextMove(1);//June
      board.nextMove(3);
      board.nextMove(5);//June
      board.nextMove(6);
      
      Assert.assertEquals(false, board.allMovesFinished());
      Assert.assertNull(board.evaluateWinner());
      
      board.nextMove(9);//June
      Assert.assertEquals(false, board.allMovesFinished());
      Assert.assertEquals(Board.Player.JUNE, board.evaluateWinner());
    }
}
