package de.hdm_stuttgart.mi.sd1.tictactoe;

import java.util.Scanner;

/**
 * Playing Tic-tac-toe with two players.
 * 
 */
public class TicTacToe {

   /**
    * @param args Unused
    */
   public static void main(String[] args) {

      final Scanner scan = new Scanner(System.in);

      System.out.println("\n\n");
      
      System.out.println("Who is going to start? " + 
        Player.YOU.ordinal() + " = " + Player.YOU.nickname +
          ", other = " + Player.COM.nickname);
      
      final int firstPlayer = scan.nextShort();
      
      final Board board;
      if (Player.YOU.ordinal() == firstPlayer) {
        board = new Board(Player.YOU);
      } else {
        board = new Board(Player.COM);
        board.nextPerfectMove();
      }
      board.print(true, true);
      
      Player winner;
      do {
         do {
            System.out.print("\n\nPlease enter next field's number:");
            final short nextField = scan.nextShort();
            final String errorMessage = board.nextMove(nextField);
            if (null == errorMessage) {
               break;                            // o.K., quit loop for next move.
            } else {
               System.err.println(errorMessage); // Field already occupied?
            }
         } while (true);
         board.nextPerfectMove();
         board.print(true, !board.allMovesFinished());
      } while (null == (winner = board.evaluateWinner()) && !board.allMovesFinished());

      if (null == winner) {
         System.out.println("\n\nGame over: draw");
      } else {
        switch(winner) {
        case YOU: System.out.println("\n\nCongratulations, you won!");break;
        case COM: System.out.println("\n\nSorry, you lost!");break;
        }
      }

      scan.close();
   }
}
