package de.hdm_stuttgart.de.sd1.leap;

/**
 * Leap year calculations
 *
 */
public class LeapYearCompact {

  /**
   * @param args unused
   */
  public static void main(String[] args) {
    System.out.println("Is 1800 a leap year? " + isLeapYear(1800));
    System.out.println("Is 2000 a leap year? " + isLeapYear(2000));
    System.out.println("Is 2016 a leap year? " + isLeapYear(2016));
  }

  /**
   * Characterizing a given year either as leap year or
   * non- leap year
   * 
   * @param year The year in question.
   * @return true if year is a leap year, false otherwise.
   */
  public static boolean isLeapYear(int year) {
    return
        year % 400 == 0 ||                  // Every 400 years we do have a leap year.
        year % 4 == 0 &&  0 != year % 100;  // Every 4 years we do have a leap year unless the year
                                            // in question is a multiple of 100.
  }  
}
