package de.hdm_stuttgart.de.sd1.math;

import org.junit.Assert;
import org.junit.Test;

/**
 * Testing factorial implementation
 *
 */
public class MaxFactorialTest{

  /**
   * Handling zero argument.
   */
  @Test
  public void testZero() {
    Assert.assertEquals(1, Math.factorial(0));
  }
  
  @Test
  public void testOne() {
    Assert.assertEquals(1, Math.factorial(1));
  }
  
  @Test
  public void testTwo() {
    Assert.assertEquals(2, Math.factorial(2));
  }
  
  @Test
  public void testThree() {
    Assert.assertEquals(6, Math.factorial(3));
  }
  
  @Test
  public void testSix() {
    Assert.assertEquals(720, Math.factorial(6));
  }
 
  @Test
  public void testOverflowLimit() {
    Assert.assertTrue(Long.MAX_VALUE > Math.factorial(20));
    Assert.assertEquals(Long.MAX_VALUE, Math.factorial(21));
  }
}
