package de.hdm_stuttgart.mi.sd1.plot;

/**
 * 2-dimensional sine function plot
 *
 */
public class PlotSine {
	
    /**
     * @param args Unused
     */
    public static void main( String[] args ) {
        plotSine();
    }
	
	static final int  // Effective size of plotting region
	  numTicsX = 170  // Number of plotting positions in x-direction
	 ,numTicsY =  60; // Number of plotting positions in y-direction
	
	static final double 
		 xMin = 0.				// x-values ranging from xMin to xMax
		,xMax = 2 * Math.PI	
		
		,yMin = -1.				// y-values ranging from yMin to yMax
		,yMax = 1.
		
		,xStepWidth = (xMax - xMin) / (numTicsX - 1)  // per step width in x-direction
		,yStepWidth = (yMax - yMin) / (numTicsY - 1); // per step width in y-direction

	static final char [][] plotRegion = new char[numTicsX][numTicsY];
	
	static void init() { // Initialize plotting region by spaces
		for (int xTics = 0; xTics < numTicsX; xTics++) {
			for (int yTics = 0; yTics < numTicsY; yTics++) {
				plotRegion[xTics][yTics] = ' ';
			}
		}
	}
	
	static void plotSine() {
		init();
		
		for (int xTics = 0; xTics < numTicsX; xTics++) {
			double x = xMin + xTics * xStepWidth;
			double sinOfX = Math.sin(x);
			
			if (yMin <= sinOfX && sinOfX <= yMax ) {
				int ySinTics = (int) Math.round((sinOfX - yMin) / (yMax - yMin) * (numTicsY - 1));
				plotRegion[xTics][ySinTics] = '*';
			}
		}
		for (int yTic = numTicsY - 1; 0 <= yTic; yTic--) {
			for (int xTic = 0; xTic < numTicsX; xTic++) {
				System.out.print(plotRegion[xTic][yTic]);
			}
			System.out.print('\n'); // Newline
		}
	}
}
