package de.hdm_stuttgart.mi.sd1.plot;


/**
 * Plotting functions based on Java 8 style lambda definitions.
 * 
 */
public class DriverLambda {

    /**
     * @param args Unused
     */
    public static void main( String[] args ) {
        final Plotter plotter = new Plotter();
        
        plotter.setNumTics(80, 40);// 80 characters vertical, 40 characters horizontal
        plotter.setXrange(0, 2 * Math.PI);
        plotter.setYrange(-1, 1);
        
        // Function implementing the underlying interface 
        // de.hdm_stuttgart.mi.sd1.plot.DoubleOfDoubleFunction
        // are being conveniently passed as arguments.
        plotter.plot(x -> Math.sin(x));
        plotter.plot(x -> Math.cos(x));
    }
}
