package de.hdm_stuttgart.de.sd1.sum;

/**
 * Summing up integer values.
 *
 */
public class Summing {

  /**
   * @param args unused
   */
  public static void main(String[] args) {
    // Simple tests
    System.out.println("1 + 2 + 3" + "=" + getSum(3));
    System.out.println("1 + 2 + ... + 150" + "=" + getSum(150));


    long start = System.nanoTime();
    System.out.println("1 + 2 + ... + 65535" + "=" + getSum(65535));
    long end = System.nanoTime();
    System.out.println("Elapsed time: " + (end - start) + " nanoseconds");
  }
  
  /**
   * Summing up all integers starting from 0 up to and including a given limit
   * Example: Let the limit be 5, then the result is 1 + 2 + 3 + 4 + 5  
   * 
   * @param limit The last number to include into the computed sum
   * @return The sum of 1 + 2 + ... + limit
   */
  public static long getSum(int limit) {
    if (limit < 0) {
      return 0;
    } else if (0 == limit % 2){       // even limit, divide by 2
      return limit / 2 * (limit + 1); // Avoiding arithmetic overflow
    } else {                          // uneven limit, divide (limit + 1 ) by 2
      return (limit + 1) / 2 * limit; // Avoiding arithmetic overflow
    }
  }
}