package de.hdm_stuttgart.mi.company.model;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

@Entity
@Table(
		uniqueConstraints= {@UniqueConstraint(columnNames={"email"})}
)
@SuppressWarnings("javadoc")
public class Employee {
	
	protected Employee(){}
	
	public Employee(final String name, final String email){
		this.name = name;
		this.email = email;
	}
	
	@Id
	@GeneratedValue
	Long id;
	
	String name, email;
	
	@OneToMany(mappedBy="employee", cascade=CascadeType.ALL)
	Set<WorksFor> projects = new HashSet<WorksFor>();

   public Long getId() { return id;}

   public String getName() {
      return name;
   }

   public void setName(String name) {
      this.name = name;
   }

   public String getEmail() {
      return email;
   }

   public void setEmail(String email) {
      this.email = email;
   }

   public Set<WorksFor> getProjects() {
      return projects;
   }

   public void setProjects(Set<WorksFor> projects) {
      this.projects = projects;
   }
}
