package jpaintro.university;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.junit.Assert;
import org.junit.Test;

import jpaintro.university.model.Lecture;

/**
 * Dealing with insertion and reading entities.
 */
public class EntityTest {
    /**
     * Creating a database entity and testing successful reload by primary key.
     */
    @Test
    public void testApp() {
       final EntityManagerFactory factory = Persistence.createEntityManagerFactory(CreateLectures.PERSISTENCE_UNIT_DROP_CREATE);
       final EntityManager em = factory.createEntityManager();
       
       final String lectureName = "Web development";

       final Long id; // Will be initialized by database generated primary key value.
       
       em.getTransaction().begin(); // Creating and storing an entity
       {
          final Lecture lh = new Lecture(lectureName, 2222);
          
          em.persist(lh);
          id = lh.getId();
       }
       em.getTransaction().commit();
       
       em.getTransaction().begin(); // Reloading the entity by its primary key
       {
          final Lecture readLh = em.find(Lecture.class, id);
          Assert.assertEquals(lectureName, readLh.getTitle());
       }
       em.getTransaction().commit();
       
       em.close();
       factory.close();
    }
}
