package de.hdm_stuttgart.mi.sda1.sql2catalog;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;
import javax.persistence.criteria.CriteriaQuery;

import org.jdom2.Element;

import de.hdm_stuttgart.mi.sda1.sql2catalog.model.Product;

/**
 * Reading product data
 *
 */
public class RdbmsAccess {

   static final EntityManagerFactory emFactory;
   static final EntityManager em;

   static {
      emFactory =  Persistence.createEntityManagerFactory("strategy_none");
      em = emFactory.createEntityManager();
   }

   /**
    * Append element to XML tree.
    * @param root
    */
   public void appendProducts(final Element root) {

      final CriteriaQuery<Product> criteria = emFactory.getCriteriaBuilder().createQuery(Product.class);
      criteria.from(Product.class);

      final EntityTransaction transaction = em.getTransaction();
      transaction.begin();{

         for (final Product p: em.createQuery(criteria).getResultList()) {

            final Element productElement = new Element("product");
            root.addContent(productElement);
            productElement.setAttribute("id", "" + p.getId());

            System.out.println(p.getName() + "++++++++++++++++++++++++++++++++++++");

            productElement.addContent(new Element("name").addContent(p.getName()));

            p.getDescriptions().stream().forEach(description -> {
               productElement.addContent(new Element("description").addContent(description.getDescription()));
            });

            p.getAge().ifPresent(age -> productElement.addContent(new Element("age").addContent(age.toString())));
         }
      }
      transaction.commit();
      em.close();
      emFactory.close();
   }
}