package de.hdm_stuttgart.mi.sda1.nocast.driver;

import java.io.IOException;

import org.jdom2.JDOMException;

import de.hdm_stuttgart.mi.sda1.nocast.DomXpath;

/**
 * Driver to test XPath based searching of &lt;img&gt; elements
 * within a given HTML document.
 *
*/
public class DomXpathDriver {

  /**
   * @param argv Unused command arguments
    * @throws JDOMException Corrupt content, failing to parse.
    * @throws IOException File access problem.
   */
  public static void main(String[] argv) throws JDOMException, IOException {
    final DomXpath imgSearch = new DomXpath();
    // The following HTML document is being searched for <img> elements.
    imgSearch.process("src/main/resources/gallery.html").stream().
      map(img -> img.getAttributeValue("src")).
      reduce((l, r) -> l.concat(", ").concat(r)).
      ifPresent(System.out::println);
  }
}