DROP TABLE IF EXISTS Description;
DROP TABLE IF EXISTS Product;

CREATE TABLE Product (
   id CHAR(20) NOT NULL PRIMARY KEY
  ,name VARCHAR(255) NOT NULL
  ,age SMALLINT
);

CREATE TABLE Description (
   product CHAR(20) NOT NULL REFERENCES Product
  ,orderIndex int NOT NULL   -- preserving the order of descriptions belonging to a given product
  ,text VARCHAR(255) NOT NULL
  ,UNIQUE(product, orderIndex)
);

-- example data corresponding to products.xml --

-- Product lacking age property --
INSERT INTO Product (id, name) VALUES ('mpt', 'Monkey Picked Tea');
INSERT INTO Description VALUES('mpt', 0, 'Picked only by specially trained monkeys');
INSERT INTO Description VALUES('mpt', 1, 'Rare wild Chinese tea');

INSERT INTO Product VALUES ('instantTent', '4-Person Instant Tent', 15);
INSERT INTO Description VALUES('instantTent', 0, 'Exclusive WeatherTec system.');
INSERT INTO Description VALUES('instantTent', 1, '4-person, 1-room tent');
INSERT INTO Description VALUES('instantTent', 2, 'Pre-attached tent poles');
