package de.hdm_stuttgart.mi.sda1.sql2catalog;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

/** Application related error messages */
public class Messages {
   static final Logger log = LogManager.getLogger(Messages.class);
   
   private static final String BUNDLE_NAME = "de.hdm_stuttgart.mi.sda1.sql2catalog.messages"; //$NON-NLS-1$

   private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle
         .getBundle(BUNDLE_NAME);

   private Messages() {
   }

   /**
    * Retrieving message corresponding to key.
    * 
    * @param key The message's key
    * @return The message content.
    */
   public static String getString(String key) {
      try {
         return RESOURCE_BUNDLE.getString(key);
      } catch (MissingResourceException e) {
         log.warn("Missing key:" + e);
         return '!' + key + '!';
      }
   }
}
