package de.hdm_stuttgart.mi.sda1.rdbmsxml2html;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

/** Driver */
public class XmlRdbms2HtmlDriver {
   static private final Logger log = LogManager.getLogger(XmlRdbms2HtmlDriver.class);


  /** @param args unused */
  public static void main(String[] args) {
    final String inFilename = "TestData/climbing.xml",
          xslFilename = "TestData/catalog2html.xsl", 
          htmlOutputFilename = "TestData/climbingprice.html";
    try {
      final XmlRdbms2Html converter = new XmlRdbms2Html(xslFilename);
      converter.transform(inFilename, htmlOutputFilename);
      log.info("Output has been written to " + htmlOutputFilename);
    } catch (Exception e) {
      System.err.println("The conversion of '" + inFilename
          + "' by stylesheet '" + xslFilename
          + "' to output HTML file '" + htmlOutputFilename
          + "' failed with the following error:" + e);
      e.printStackTrace();
    }
  }
}