package de.hdm_stuttgart.mi.sda2.jpa.billing;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;
import javax.persistence.Query;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import de.hdm_stuttgart.mi.sda2.jpa.billing.domain.BillingDetail;
import de.hdm_stuttgart.mi.sda2.jpa.billing.domain.Customer;

/**
 * A simple http://logging.apache.org/log4j/2.x demo, see file log4j2.xml for
 * configuration options.
 * 
 */
public class ReadData {
   private static Logger log = LogManager.getLogger(ReadData.class);

   /**
    * @param args Unused
    */
   @SuppressWarnings("unchecked")
   public static void main(String[] args) {

      final EntityManagerFactory factory = Persistence
            .createEntityManagerFactory("persistenceReadUnit");
      final EntityManager manager = factory.createEntityManager();

      final EntityTransaction tx = manager.getTransaction();

      final Query searchCustomer = manager.createQuery("select c from Customer c");
      tx.begin();
      {
         final List<Customer> customers = searchCustomer.getResultList();
         
         for (final Customer c: customers) {
            System.out.println("---------------------\n" + c.getName());
            for (final BillingDetail b : c.getBillings()) {
               System.out.println(b);
            }
         }
      }
      tx.commit();
      log.info("done!");

   }

}
