package de.hdm_stuttgart.mi.sda2.jpa.billing.domain;


import javax.persistence.CascadeType;
import javax.persistence.DiscriminatorColumn;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.ManyToOne;

/**
 * Base class for payment related purposes
 *
 */
@Entity
@Inheritance(strategy=InheritanceType.SINGLE_TABLE)
@DiscriminatorColumn(name="")
public abstract class BillingDetail {
   @Id
   @GeneratedValue(strategy=GenerationType.IDENTITY)
   Long id;

   @ManyToOne(cascade= CascadeType.ALL)
   Customer customer;

   
   protected BillingDetail() {}
   
   public BillingDetail(Customer customer) {
      customer.addBilling(this);
   }
   

   @SuppressWarnings("javadoc")
   public Long getId() {
      return id;
   }
   
   public Customer getCustomer() {
      return customer;
   }

   public void setCustomer(Customer customer) {
      this.customer = customer;
   }

   @Override
   public String toString() {
      return "Account of " + customer.getName();
   }
   
   
   
}
