package de.hdm_stuttgart.mi.sda2.jpa.cd.domain;

import static javax.persistence.CascadeType.PERSIST;
import static javax.persistence.CascadeType.REMOVE;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.ElementCollection;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.OrderColumn;
import javax.persistence.Table;


@Entity @Table(name = "Student")
public class Student {
   @Id
   @GeneratedValue(strategy=GenerationType.IDENTITY)
   Long  id;
   
   @Column(nullable=false)
   String fullName;
   
   @Column(unique=true, nullable=false)
   int matriculation;
   
   @ElementCollection
   final Set<String> emails = new HashSet<String>();
   
   @ElementCollection
   @OrderColumn
   final List<Address> addresses = new ArrayList<Address>();

   @OneToMany(mappedBy="student", cascade={PERSIST, REMOVE})
   Set<StudentLecture> lectures = new HashSet<StudentLecture>();
   
   protected Student() {}
   
   public Set<StudentLecture> getLectures() {
      return lectures;
   }
   public void setLectures(Set<StudentLecture> lectures) {
      this.lectures = lectures;
   }

   public Student(final String fullName, int matriculation) {
      setFullName(fullName);
      setMatriculation(matriculation);
   }
   public String getFullName() {
      return fullName;
   }
   public void setFullName(String fullName) {
      this.fullName = fullName;
   }
   public int getMatriculation() {
      return matriculation;
   }
   public void setMatriculation(int matriculation) {
      this.matriculation = matriculation;
   }
   public Long getId() {
      return id;
   }
   public Set<String> getEmails() {
      return emails;
   }
   public List<Address> getAddresses() {
      return addresses;
   }
   
}
