package de.hdm_stuttgart.mi.sda2.usermanage.rdbms;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Statement;

public class MyNamedQuery <T extends Param>{
	
	final PreparedStatement statement;
	
	/**
	 * See {@link Connection#prepareStatement(String, int)}.
	 * @param conn
	 * @param t An arbitrary enum param value belonging to the SQL statement in question
	 * @param autoGeneratedKeys
	 * @throws SQLException
	 */
	public MyNamedQuery(final Connection conn, final T t, final int autoGeneratedKeys) 
	  throws SQLException {
		statement = conn.prepareStatement(t.getSql(), autoGeneratedKeys);
	}
	
	public void setString(T t, String value) throws SQLException {
		statement.setString(t.getIndex(), value);
	}
	
	public void setInt(T t, int value) throws SQLException {
		statement.setInt(t.getIndex(), value);
	}

	public PreparedStatement getStatement() {
		return statement;
	}
    /**
     * Executes all of the batched statements.
     * 
     * See {@link Statement#executeBatch()} for details.
     * @return update counts for each statement
     * @throws SQLException if something went wrong
     */
    public int[] executeBatch() throws SQLException {
        return statement.executeBatch();
    }
}
