package de.hdm_stuttgart.mi.sda2.account;

import java.sql.Connection;
import java.sql.SQLException;

import javafx.application.Application;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.GridPane;
import javafx.scene.text.Font;
import javafx.scene.text.FontWeight;
import javafx.scene.text.Text;
import javafx.stage.Stage;
import de.hdm_stuttgart.mi.sda2.account.gui.ExceptionDialog;
import de.hdm_stuttgart.mi.sda2.account.sql.DbHandler;

public class SumDriver extends Application {

	final DbHandler dbh = new DbHandler(new ExceptionDialog());
	
    final TextField accountSum = new TextField();
    
    final Button
		refreshBtn = new Button("Refresh");
    
    public static void main( String[] args ) {
    	launch(args);
    }
    public SumDriver() {
    	dbh.connect(Connection.TRANSACTION_READ_UNCOMMITTED, true);
    	refreshBtn.setOnAction(event-> {
    		accountSum.setText("" + dbh.getAccountSum());
    		});
    	
    	accountSum.setEditable(false);
    	accountSum.setText("" + dbh.getAccountSum());
    }
    
    @Override
    public void start(final Stage primaryStage) throws SQLException {
    	

        primaryStage.setTitle("Browsing accounts");
        
        final GridPane grid = new GridPane();
        grid.setAlignment(Pos.CENTER);
        grid.setHgap(10);
        grid.setVgap(10);
        grid.setPadding(new Insets(25, 25, 25, 25));
        
        int currentRowIndex = 0;
        final Text scenetitle = new Text("Sum of balances");
        scenetitle.setFont(Font.font("Tahoma", FontWeight.NORMAL, 20));
        grid.add(scenetitle, 0, currentRowIndex, 2, 1);
        
        currentRowIndex++;
        grid.add(new Label("Balances sum:"), 0, currentRowIndex);
        grid.add(accountSum, 1, currentRowIndex);

        currentRowIndex++;
        grid.add(refreshBtn, 1, currentRowIndex);
        
        Scene scene = new Scene(grid, 300, 250);
        primaryStage.setScene(scene);
        primaryStage.show();
        
    }
    
    @Override
	public void stop() throws Exception {
		super.stop();
        dbh.close();
	}
}
