package de.hdm_stuttgart.mi.sdai.readmydata;

import org.ldaptive.BindConnectionInitializer;
import org.ldaptive.ConnectionConfig;
import org.ldaptive.ConnectionFactory;
import org.ldaptive.Credential;
import org.ldaptive.DefaultConnectionFactory;
import org.ldaptive.LdapAttribute;
import org.ldaptive.LdapEntry;
import org.ldaptive.LdapException;
import org.ldaptive.SearchExecutor;
import org.ldaptive.SearchResult;

public class ReadMyLdap {

   /**
    * @param args Unused
    * @throws LdapException
    */
   public static void main(String[] args) throws LdapException {
      
      final ConnectionConfig connConfig = new ConnectionConfig("ldap://ldap1.mi.hdm-stuttgart.de"); 
      connConfig.setUseStartTLS(true);
      connConfig.setConnectionInitializer(
            new BindConnectionInitializer(
                  Messages.getString("ReadMyLdap.bindDn"), 
              new Credential(Messages.getString("ReadMyLdap.bindPassword")))); 
      
      final ConnectionFactory cf = new DefaultConnectionFactory(connConfig);

      final SearchExecutor executor = new SearchExecutor();

      executor.setBaseDn("ou=userlist, dc=hdm-stuttgart, dc=de"); //$NON-NLS-1$
      final SearchResult result = executor.search(cf, "(uid=mistudent)").getResult(); //$NON-NLS-1$

      final LdapEntry entry = result.getEntry();

      
      
      for (final LdapAttribute att: entry.getAttributes()) {
         if (att.isBinary()) {
            System.out.println("Not displaying value of binary attribute '" + att.getName() + "'"); //$NON-NLS-1$ //$NON-NLS-2$
         } else {
            final int size = att.size(); 
            if (1 == size) {
               System.out.println(att.getName() + ": " + att.getStringValue()); //$NON-NLS-1$
            } else {
               int i = 0;
               for (final String value: att.getStringValues()) {
                  System.out.println(att.getName() + "[" + i++  + "]: " + value); //$NON-NLS-1$ //$NON-NLS-2$
               }
            }
         }
      }
   }
}
