package de.hdm_stuttgart.mi.sd1.test.aufgabe1;

import static org.junit.Assert.assertEquals;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.sd1.aufgabe1.Diff;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class TestMaxDiff extends ExaminationTestDefaults {

  @Test
  public void test01Zero() {
    assertEquals(0, Diff.maxDiff(0, 0, 0));
  }

  @Test
  public void test02Equal() {
    assertEquals(0, Diff.maxDiff(1, 1, 1));
  }

  @Test
  public void test03AscendingValues() {
    assertEquals(2, Diff.maxDiff(1, 2, 3));
  }

  @Test
  public void test04DescendingValues() {
    assertEquals(7, Diff.maxDiff(7, 5, 0));
  }

  @Test
  public void test05Middle() {
    assertEquals(3, Diff.maxDiff(4, 1, 4));
  }

  @Test
  public void test06Negative() {
    assertEquals(3, Diff.maxDiff(-1, -2, -4));
  }

  @Test
  public void test07Mixed() {
    assertEquals(15, Diff.maxDiff(-5, 10, 0));
    assertEquals(37, Diff.maxDiff(-5, 30, -7));
  }
}
