package de.hdm_stuttgart.mi.sd1.test.aufgabe1;

import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.aufgabe1.BodenlegerKosten;

/**
 * <p>Testen des Auftretens eines Teil-String in einem vorgegebenen String.</p>
 *
 */
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class TestBodenlegerKosten extends ExaminationTestDefaults {

   static final double delta = 1E-15;// Toleranz bei double Wertvergleichen

  /**
   * Raumfläche.
   */
  @Test
  @Marking(points=3)
  public void test_100() {
    Assert.assertEquals(
      15,
      new BodenlegerKosten(5, 3).getFlaeche(), delta);
  }

  /**
   * Raumumfang.
   */
  @Test
  @Marking(points=3)
  public void test_110() {
    Assert.assertEquals(
      16,
      new BodenlegerKosten(5, 3).getUmfang(), delta);
  }

  /**
   * Basiskosten Verlegung
   */
  @Test
  @Marking(points=3)
  public void test_200() {
    Assert.assertEquals(
      296.30,
      new BodenlegerKosten(5, 3).getVerlegungskosten(17.3, 2.3),
      delta);
    Assert.assertEquals(
      296.30,
      new BodenlegerKosten(3, 5).getVerlegungskosten(17.3, 2.3),
      delta);
  }

  /**
   * Gesamtkosten mit Anfahrtskosten
   */
  @Test
  @Marking(points=3)
  public void test_300() {
    Assert.assertEquals(
      163.5,
      new BodenlegerKosten(2, 3).getGesamtKosten(18, 3, 85),
      delta);
  }

  /**
   * Gesamtkosten, Anfahrtskosten entfallen
   */
  @Test
  @Marking(points=3)
  public void test_320() {
    Assert.assertEquals(
      3800,
      new BodenlegerKosten(10, 15).getGesamtKosten(24, 4, 85),
      delta);
  }


}