package de.hdm_stuttgart.mi.sd1.aufgabe1;


/**
 * Hilfsmethoden.
 *
 */
public class Helper {
   
   /**
    * <p>Liefert die Deutschen Klartextnamen der Zahlen von 0 bis Zwölf, also:</p>
    * 
    *  <p>{0, 1, 2, ..., 12} wird zu {"null", "eins", "zwei", ..., "zwölf"}</p>
    *  
    *  <p>Für alle anderen Werte, wie z.B. »14«, soll "Uuups, keine Regel
    *     für den Wert 14" zurückgegeben werden.</p>
    * 
    * @param a Umzuwandelnder Wert
    * @return Klartextname.
    */
   static public String klartextName(final int a) {
      switch(a) {
      case 0: return "null";
      case 1: return "eins";
      case 2: return "zwei";
      case 3: return "drei";
      case 4: return "vier";
      case 5: return "fünf";
      case 6: return "sechs";
      case 7: return "sieben";
      case 8: return "acht";
      case 9: return "neun";
      case 10: return "zehn";
      case 11: return "elf";
      case 12: return "zwölf";

      default : return "Uuups, keine Regel für den Wert " + a;
      }
   }

   /**
    * <p>Gibt den Betrag des Produkts der beiden Faktoren zurück.</p> 
    * 
    * @param a Erster Wert
    * @param b Zweiter Wert
    * @return Betrag des Produkts.
    */
   static public int getProduktBetrag(final int a, final int b) {
      return Math.abs(a * b);
   }

   /**
    * <p>Der Quadrant für einen gegebenen Winkel.</p> 
    * 
    * <p>Der Vollkreis wird in 0 bis 360 Grad eingeteilt. Je nach Winkel liegt ein Vektor
    * im Quadrant 1, 2 3 oder 4:</p> 
    *
    * <pre>
    *              |
    * Quadrant 2   |  Quadrant 1
    *              |
    *              |
    *--------------+-------------
    *              |
    *              |
    * Quadrant 3   | Quadrant 4
    *              |</pre>
    *              
    *  <p>Beispiel: 45 Grad liegt im ersten Quadranten, 200 Grad im Dritten.</p>            
    *  
    * @param winkel Winkel des zu betrachtenden Vektors aus dem Intervall [0, 360[.
    * @return zugehöriger Quadrant.
    */
   static public int getQuadrant(final double winkel) {
      if (winkel < 90) {
         return 1;
      } else if (winkel < 180) {
         return 2;
      } else if (winkel < 270) {
         return 3;
      } else {
         return 4;
      }
   }
	
   /**
    * <p>Umwandlung von Sekundenangaben in das Format hh:mm:ss.</p> 
    * 
    * <p>Beispiel: 7290 Sekunden entsprechen 2 Stunden, einer Minute und 30 Sekunden, also "2:1:30"</p> 
    * 
    * @param sekunden Nicht-negative Sekundenangabe
    * @return Angabe in Stunden:Minuten:Sekunden
    */
   static public String getZeitangabe(final long sekunden) {
      final long stunden = sekunden / (60 * 60);
      long rest = sekunden  % (60 * 60);
      long minuten = rest / 60;
      rest = rest % 60;
      return stunden + ":" + minuten + ":" + rest;
   }
}
