<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xs="http://www.w3.org/2001/XMLSchema"
  xmlns:d="http://docbook.org/ns/docbook"
  xmlns:m="http://www.w3.org/1998/Math/MathML"
  xmlns="http://www.w3.org/1999/xhtml"
  exclude-result-prefixes="d xs m"
  version="2.0">
  
  <xsl:variable name="n">
    <xsl:text>
</xsl:text>
  </xsl:variable>
  
  
  <xsl:template name="hdm.get.leftmost.of.separator">
    <xsl:param name="path"/>
    <xsl:param name="separator"/>
    <xsl:param name="start">1</xsl:param>
    <xsl:if test="contains($path, $separator )">
      <xsl:if test="$start='0'">
        <xsl:value-of select="$separator"/>
      </xsl:if>
      <xsl:value-of select="substring-before($path, $separator)"/>
      <xsl:call-template name="hdm.get.leftmost.of.separator">
        <xsl:with-param name="path" select="substring-after($path, $separator)"/>
        <xsl:with-param name="separator" select="$separator"/>
        <xsl:with-param name="start">0</xsl:with-param>
      </xsl:call-template>
    </xsl:if>
  </xsl:template> 
  
  <xsl:param name="toggleDisplayScript">
    <script src="docbooksupplement.js"></script>
  </xsl:param>
  
  <!--Allow for opening and closing of answers -->  
  <xsl:template match="d:answer" priority="1">
    <xsl:variable name="deflabel">
      <xsl:apply-templates select="." mode="qanda.defaultlabel"/>
    </xsl:variable>
    
    <tr>
      <xsl:apply-templates select="." mode="common.html.attributes"/>
      <xsl:call-template name="id.attribute"/>
      <td align="{$direction.align.start}" valign="top">
        <xsl:call-template name="anchor"/>
        <xsl:variable name="answer.label">
          <xsl:apply-templates select="." mode="label.markup"/>
        </xsl:variable>
        <xsl:if test="string-length($answer.label) &gt; 0">
          <p><strong>
            <xsl:copy-of select="$answer.label"/>
          </strong></p>
        </xsl:if>
      </td>
      <td align="{$direction.align.start}" valign="top">
        <input class="hideSolution" type="button" /> <!--goik: start "header" clickable answer modification -->
        <div>                                        <!--goik: end "header" clickable answer modification -->
          <xsl:apply-templates select="*[local-name(.) != 'label'         and local-name(.) != 'qandaentry']"/>
          <!-- * handle nested answer/qandaentry instances -->
          <!-- * (bug 1509043 from Daniel Leidert) -->
          <xsl:if test="descendant::d:question">
            <xsl:call-template name="process.qandaset"/>
          </xsl:if>
        </div>                                                         <!--goik: "footer" clickable answer modification -->        
      </td>
    </tr>
  </xsl:template>
  
  <!-- avoid namespace prefix since some epub readers get confused. Credits to
    http://stackoverflow.com/questions/16810039/how-to-remove-namespace-prefix-leaving-namespace-value-xslt
  -->
  <xsl:template match="m:math[not(@alttext)]" priority="2">
    <xsl:element name="{local-name()}" namespace="http://www.w3.org/1998/Math/MathML">
      <xsl:attribute name="alttext">math formula</xsl:attribute>
      <xsl:copy-of select="@*"/>
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>
  
  <xsl:template match="m:*" priority="1">
    <xsl:element name="{local-name()}" namespace="http://www.w3.org/1998/Math/MathML">
      <xsl:copy-of select="@*"/>
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>
  
</xsl:stylesheet>
