<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:d="http://docbook.org/ns/docbook"
    exclude-result-prefixes="d"
    version="1.1">
    
    <xsl:template match="d:imagedata" mode="goik">
        
        <xsl:variable name="dirPath">
            <xsl:call-template name="hdm.get.leftmost.of.seperator">
                <xsl:with-param name="path" select="@fileref"/>
                <xsl:with-param name="seperator" select="'/'"/>
            </xsl:call-template>
        </xsl:variable>
        
        <xsl:variable name="fileName">
            <xsl:call-template name="hdm.get.pure.filename">
                <xsl:with-param name="path" select="@fileref"/>
            </xsl:call-template>
        </xsl:variable>
        
        <xsl:variable name="fileBaseName">
            <xsl:call-template name="hdm.get.leftmost.of.seperator">
                <xsl:with-param name="path" select="$fileName"/>
                <xsl:with-param name="seperator" select="'.'"/>
            </xsl:call-template>
        </xsl:variable>
        
        <xsl:variable name="moduleBaseName">
            <xsl:call-template name="hdm.get.leftmost.of.seperator">
                <xsl:with-param name="path" select="ancestor::*/@xml:base"/>
                <xsl:with-param name="seperator" select="'/'"/>
            </xsl:call-template>
        </xsl:variable>
        
        <xsl:variable name="fullGenerateBasename" >
            <xsl:value-of select="$dirPath"/>
            <xsl:text>/Generate/</xsl:text>
            <xsl:value-of select="$moduleBaseName"/>
            <xsl:text>/</xsl:text>
            <xsl:value-of select="$fileBaseName"/>
        </xsl:variable>
        
        <xsl:document method="text" encoding="utf-8" href="{$fullGenerateBasename}.tex">
            <xsl:text>\input{../pre.tex}
                \begin{mycenterframe}{</xsl:text>
            <xsl:choose>  
              <xsl:when test="ancestor::d:figure">
                <xsl:apply-templates select="ancestor::d:figure" mode="object.title.markup.textonly"/>
              </xsl:when>  
              <xsl:otherwise>-</xsl:otherwise>  
            </xsl:choose>  
            <xsl:text>}
                \multifigure{</xsl:text>
            <xsl:value-of select="$fileBaseName" />
            <xsl:text>}
                \end{mycenterframe}
                \end{document}</xsl:text>
        </xsl:document>

    </xsl:template>
    
    
    <xsl:template name="hdm.get.leftmost.of.seperator">
        <xsl:param name="path"/>
        <xsl:param name="seperator"/>
        <xsl:param name="start">1</xsl:param>
        <xsl:if test="contains($path, $seperator )">
            <xsl:if test="$start='0'">
                <xsl:value-of select="$seperator"/>
            </xsl:if>
            <xsl:value-of select="substring-before($path, $seperator)"/>
            <xsl:call-template name="hdm.get.leftmost.of.seperator">
                <xsl:with-param name="path" select="substring-after($path, $seperator)"/>
                <xsl:with-param name="seperator" select="$seperator"/>
                <xsl:with-param name="start">0</xsl:with-param>
            </xsl:call-template>
        </xsl:if>
    </xsl:template>    
    <xsl:template name="hdm.get.pure.filename">
        <xsl:param name="path"/>
        <xsl:choose>
            <xsl:when test="contains($path, '/' )">
                <xsl:call-template name="hdm.get.pure.filename">
                    <xsl:with-param name="path">
                        <xsl:value-of select="substring-after($path, '/')"/>
                    </xsl:with-param>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="$path"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    
</xsl:stylesheet>
