<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0"
  xmlns:d="http://docbook.org/ns/docbook"
  exclude-result-prefixes="d">
    
  <xsl:import href="../../docbook-xsl/webhelp/xsl/webhelp.xsl"/>
  
  <xsl:include href="common.xsl"/>
  
  <xsl:output indent="no" method="xml"/>
  
  <xsl:template match="/">
      <map prefix="goiklecture">
        <xsl:apply-templates select="d:book/d:part[contains(@annotations, 'forumId=')]//(d:figure|d:qandaset)"/>
      </map>
  </xsl:template>
  
  <xsl:template match="d:figure">
      <entry >
        <xsl:attribute name="id">
          <xsl:value-of select="@xml:id"/>
        </xsl:attribute>
        
        <title>
          <xsl:text>Slide "</xsl:text>
          <xsl:value-of select="d:title"/>
          <xsl:text>"</xsl:text>
        </title>
        <content>
          <xsl:text>Discussing [Slide "</xsl:text>
          <xsl:value-of select="d:title"/>
          <xsl:text>"](https://freedocs.mi.hdm-stuttgart.de/</xsl:text>
          <xsl:call-template name="href.target.uri"/>
          <xsl:text>)</xsl:text>
        </content>
      </entry>
  </xsl:template>
  
  <xsl:template match="d:qandaset">    
    <entry >
      <xsl:attribute name="id">
        <xsl:value-of select="@xml:id"/>
      </xsl:attribute>
      
      <xsl:variable name="title">
        <xsl:apply-templates select="." mode="selectOwnOrInheritedTitleFlat"/>
      </xsl:variable>
      <title>
        <xsl:text>Exercise "</xsl:text>
        <xsl:value-of select="$title"/>
        <xsl:text>"</xsl:text>
      </title>
      <content>
        <xsl:text>Discussing [Exercise "</xsl:text>
        <xsl:value-of select="$title"/>
        <xsl:text>"](https://freedocs.mi.hdm-stuttgart.de/</xsl:text>
        <xsl:call-template name="href.target.uri"/>
        <xsl:text>)</xsl:text>
      </content>
      
    </entry>
  </xsl:template>
  
</xsl:stylesheet>
