package de.hdm_stuttgart.mi.exam.unitmarking;

import org.junit.runner.JUnitCore;

public class RunTests {

   static public final MarkingListener markingListener = new MarkingListener();

   @SafeVarargs
   public static void exec(Class<? extends Object> ... classz) {

      final JUnitCore jc = new JUnitCore();
      jc.addListener(markingListener);

      System.setOut(DummyPrintStream.out);
      jc.run(classz);
      System.setOut(DummyPrintStream.systemDotOut);
      System.out.println(RunTests.getMarking());
   }

   @SafeVarargs
   public static void exec(final String exerciseTitle, Class<? extends Object> ... classz) {
      markingListener.clear();
      final JUnitCore jc = new JUnitCore();
      jc.addListener(markingListener);

      System.setOut(DummyPrintStream.out);
      jc.run(classz);
      System.setOut(DummyPrintStream.systemDotOut);
      System.out.println(RunTests.getMarking(exerciseTitle));
      System.out.println("-----------------------------------------------------\n");
   }

   static public String getMarking() {
      return markingListener.getPointSumms();
   }

   static public String getMarking(final String exerciseTitle) {
      return markingListener.getPointSumms(exerciseTitle);
   }
}
