<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:d="http://docbook.org/ns/docbook"
  xmlns:m="http://www.w3.org/1998/Math/MathML"
  xmlns="http://www.w3.org/1999/xhtml"
  exclude-result-prefixes="d"
  version="1.1">
  
  <xsl:template name="user.head.content">
    <xsl:param name="node"/>
    
          <script type="text/javascript"> <!-- goiks extension head start -->
          function toggleDisplay(inputEl) {
            divElem = nextSibling(inputEl);
            if (divElem.style.visibility == 'hidden') {
              divElem.style.visibility = 'visible';
              inputEl.setAttribute('value','-');
            } else {
              divElem.style.visibility = 'hidden';
              inputEl.setAttribute('value','+');
            }
          }
          function nextSibling(n) {
            x=n.nextSibling;
            while (x.nodeType!=1) {
              x=x.nextSibling;
            }
          return x;
          }
            </script>
    
    <xsl:if test="//m:math">
      <script type="text/x-mathjax-config">MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});</script>
      <script src="https://prog.mi.hdm-stuttgart.de/mathjax/MathJax.js?config=TeX-AMS-MML_HTMLorMML">
        <xsl:comment>Self closing tags disallowed!</xsl:comment>
      </script>
    </xsl:if>
  </xsl:template>
  
  <xsl:template match="m:*">
    <xsl:element name="{local-name()}">
      <xsl:copy-of select="@*"/>
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>
  
  <xsl:template match="d:videodata">
    <video controls="controls" preload="auto">
      <xsl:attribute name="title">
        <xsl:value-of select="normalize-space(../../../d:title)"/>
      </xsl:attribute>
      
      <xsl:variable name="hdm_ImageFilename"> <!-- hdm_ prefix: do not mess with docbook! -->
        <xsl:call-template name="mediaobject.filename">
          <xsl:with-param name="object" select=".."/>
        </xsl:call-template>
      </xsl:variable>
      
      <source src="{$hdm_ImageFilename}" type='video/mp4' />
      <source src="{$hdm_ImageFilename}.ogv"/>
    </video>
  </xsl:template>
  
</xsl:stylesheet>
