package entity.company1;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

/**
 * Persisting {@link Employee} possibly along with
 * personally assigned laptops. Persisting dependent
 * transient objects corrects bug in {@link Persist1} 
 *
 */
public class Persist2 {

   /**
    * @param args not used.
    */
   public static void main(String[] args) {
      final EntityManagerFactory factory = Persistence.createEntityManagerFactory("entityCompany1PU");
      final EntityManager em = factory.createEntityManager();

      em.getTransaction().begin();
      {
         final Employee  martin = new Employee(123, "Martin Goik"),
               eve = new Employee(140, "Eve Blix");

         final Laptop superCoolGadget = new Laptop(2213);
         eve.setLaptop(superCoolGadget);
         em.persist(martin);
         em.persist(eve);
         em.persist(superCoolGadget);
      }
      em.getTransaction().commit();

      em.close();
      factory.close();
   }
}