package entity.company7.model;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

/**
 * 
 *         {@link Project} instances related to {@link Employee}
 * 
 */
@Entity
@Table(uniqueConstraints={@UniqueConstraint(columnNames={"no"})})
public class Project {

  @Id
  @GeneratedValue(strategy=GenerationType.IDENTITY)
  public Long getId() {return id;}
  protected void setId(Long id) {this.id = id;}
  private Long id;

  public int getNo() { return no;}
  public void setNo(int no) { this.no = no;}
  int no;
  
  public String getTitle() { return title;}
  public void setTitle(String title) { this.title = title;}
  String title;
  
  @ManyToMany(mappedBy="projects")
  public Set<Employee> getCollaborators() { return collaborators;}
  public void setCollaborators(Set<Employee> collaborators) { this.collaborators = collaborators;}
  private Set<Employee> collaborators = new HashSet<Employee>();
  
  protected Project(){}

  public Project(final int no, final String title) {
    setNo(no);
    setTitle(title);
  }
  @Override
  public boolean equals(Object other) {
    if (this == other) {
      return true;
    } else if (other instanceof Project) {
      return getNo() == ((Project) other).getNo();
    } else {
      return false;
    }
  }
  @Override
  public int hashCode() { return getNo();}
}