package entity.company8.model;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

/**
 *         {@link Employee} and {@link Project} related by
 *         {@link EmployeeProject} and {@link OneToMany} / {@link ManyToOne}
 */
@Entity
@Table(uniqueConstraints={@UniqueConstraint(columnNames={"staffNumber"})})
public class Employee {

  @Id
  @GeneratedValue(strategy=GenerationType.IDENTITY)
  public Long getId() {return id;}
  protected void setId(Long id) {this.id = id;}
  private Long id;

  public int getStaffNumber() { return staffNumber;}
  public void setStaffNumber(int staffNumber) { this.staffNumber = staffNumber;}
  int staffNumber = Integer.MIN_VALUE;

  public String getCname() { return cname;}
  public void setCname(String cname) { this.cname = cname;}
  private String cname; // Common name

  @OneToMany(orphanRemoval=true,fetch = FetchType.LAZY, mappedBy ="pk.employee",
        cascade = {CascadeType.PERSIST, CascadeType.MERGE})
  public Set<EmployeeProject> getEmployeeProjects() { return employeeProjects;}
  public void setEmployeeProjects(Set<EmployeeProject> employeeProjects) { this.employeeProjects = employeeProjects;}
  private Set<EmployeeProject> employeeProjects = new HashSet<EmployeeProject>();

  protected Employee(){}

  public Employee(final int staffNumber, final String cname) {
    setStaffNumber(staffNumber);
    setCname(cname);
  }
  @Override
  public boolean equals(Object other) {
    if (this == other) {
      return true;
    } else if (other instanceof Employee) {
      return getStaffNumber() == ((Employee) other).getStaffNumber();
    } else {
      return false;
    }
  }
  @Override
  public int hashCode() { return getStaffNumber();}
}