package hibintro.v1;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.TypedQuery;

/**
 * Retrieval of all {@link User} objects from a database.
 */
public class RetrieveAll {

   /**
    * Retrieving users containing the letter <code>r</code> in
    * {@link User#getCname()}.
    * 
    * @param args unused
    */
   public static void main(String[] args) {
      final EntityManagerFactory factory = Persistence.createEntityManagerFactory("hibintroV1PU");
      final EntityManager em = factory.createEntityManager();

      em.getTransaction().begin();
      {
         final TypedQuery<User> searchUsers = em.createQuery("from User", User.class);
         final List<User> users = searchUsers.getResultList();
         for (final User u: users) {
            System.out.println("uid=" + u.getUid() + ", " + u.getCname());
         }
      }
      em.getTransaction().commit();

      em.close();
      factory.close();
   }
}