package hibintro.v1;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.TypedQuery;

/**
 * Retrieval of {@link User} objects from a database.
 *
 */
public class SelectUser {

  /**
   * @param args not used.
   */
  public static void main(String[] args) {
     final EntityManagerFactory factory = Persistence.createEntityManagerFactory("hibintroV1PU");
     final EntityManager em = factory.createEntityManager();

     em.getTransaction().begin();
     {
        final TypedQuery<User> query = em.createQuery(
              "from User u where u.cname like '%e%'", User.class);
        
        final List<User> users = query.getResultList();
        for (final User u: users) {
          System.out.println("Found user '" + u.getCname() + "'");
        }
     }
     em.getTransaction().commit();

     em.close();
     factory.close();
  }
}