package inherit.joined.v1;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;

/**
 *   Root class for different payment methods
 */
@Entity
@Inheritance(strategy=InheritanceType.JOINED)
public abstract class BillingDetails {
   
   private Long id;
   @Id
   @GeneratedValue(strategy = GenerationType.IDENTITY)
   public Long getId() {return id;}
   protected void setId(Long id) {this.id = id;}
   
   private String number;
   /**
    * @return May be credit card or bank account number
    */
   @Column(nullable = false, length = 32)
   public final String getNumber() {return number;}
   public final void setNumber(String number) {this.number = number;}

   private Date created = new Date();
   @Column(nullable = false)
   public Date getCreated() {return created;}
   public void setCreated(Date created) {this.created = created;}
   
   protected BillingDetails() {}
   public BillingDetails(final String number) {
      setNumber(number);
   }
   @Override
   public String toString() {
      return getClass().getSimpleName() + ": number=" + getNumber() + 
               ", created " + getCreated();
   }
   
}