package inherit.joined.v2;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.TypedQuery;

/**
 * Retrieval of all {@link Circle} objects from a database.
 */
public class RetrieveRectangles {

  /**
   * @param args unused
   */
  public static void main(String[] args) {
     final EntityManagerFactory factory = Persistence.createEntityManagerFactory("inheritJoinedV2PU");
     final EntityManager em = factory.createEntityManager();

     em.getTransaction().begin();
     {
        final TypedQuery<Rectangle> searchRectangles = em.createQuery("from Rectangle", Rectangle.class);

        for (final Rectangle r: searchRectangles.getResultList()) {
          System.out.println(r);
        }
     }
     em.getTransaction().commit();

     em.close();
     factory.close();
  }
}