package session2;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

/**
 * Repeated retrieval of a single {@link User} object from a database.
 *
 */
public class LoadUser {

   /**
    * Retrieving a single {@link User} instance by means
    * of its primary key value two times in succession.
    * @param args unused
    */
   public static void main(String[] args) {
      
      final EntityManagerFactory factory = Persistence.createEntityManagerFactory("session2PU");
      final EntityManager em = factory.createEntityManager();

      final User user;
      
      em.getTransaction().begin();
      {
         user = em.find(User.class, 1L);
         final User user1 = em.find(User.class, 1L);
         System.out.println(" first transaction: user.equals(user1):" + user.equals(user1));
      }
      em.getTransaction().commit();

      em.getTransaction().begin();
      {
         final User user2 = em.find(User.class, 1L);
         System.out.println("second transaction: user.equals(user2):" + user.equals(user2));
      }
      em.getTransaction().commit();

      em.close();
      factory.close();
   }
}