package session3;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

/**
 * Comparing newly created {@link User} instances both with persistent
 * and transient partners.
 *
 */
public class CompareNewlyCreated {

  public static void main(String[] args) {

    // Create two transient instances
    final User a = new User(123, "goik", "Martin Goik"),
        b = new User(123, "goik", "Martin Goik");

    System.out.println("a.equals(b):" + a.equals(b));

    final EntityManagerFactory factory = Persistence.createEntityManagerFactory("session3PU");
    final EntityManager em = factory.createEntityManager();

    em.getTransaction().begin();
    {
       // previously saved as  new User(123, "goik", "Martin Goik");
       final User user = em.find(User.class, 1L);
       System.out.println("a.equals(user)):" + a.equals(user));
    }
    em.getTransaction().commit();

    em.close();
    factory.close();
  }
}