<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
  xmlns:fo="http://www.w3.org/1999/XSL/Format" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:rx="http://www.renderx.com/XSL/Extensions">

  <xsl:output method="xml" indent="yes"/>

  <xsl:template match="/">
    <fo:root font-size="10pt">

      <fo:layout-master-set>

        <fo:simple-page-master master-name="productPage"
          page-width="80mm" page-height="110mm" margin="5mm">
          <fo:region-body margin="15mm"/>
          <fo:region-before extent="10mm"/>
          <fo:region-after extent="10mm"/>
        </fo:simple-page-master>
      </fo:layout-master-set>

      <xsl:apply-templates select="catalog/product"/>
    </fo:root>
  </xsl:template>

  <xsl:template match="product">
    <fo:page-sequence master-reference="productPage">
      <fo:static-content flow-name="xsl-region-before">
        <fo:block font-weight="bold">
          <xsl:value-of select="title"/>
        </fo:block>
        <fo:block>
          <fo:leader leader-pattern="rule" leader-length="100%"/>
        </fo:block>
      </fo:static-content>
      <fo:static-content flow-name="xsl-region-after">
        <fo:block>
          <fo:leader leader-pattern="rule" leader-length="100%"/>
        </fo:block>
        <fo:block text-align="center">
          <xsl:text>page </xsl:text>
          <fo:page-number/>
        </fo:block>
      </fo:static-content>
      <fo:flow flow-name="xsl-region-body">
        <xsl:apply-templates select="description/para"/>

        <fo:table border-style="solid" border="1mm" space-before="20px">
          <fo:table-column width="40%" background-color="#AAAAAA"/>
          <fo:table-column/>
          <fo:table-body>
            <fo:table-row>
              <fo:table-cell>
                <fo:block text-align="right">Price:</fo:block>
              </fo:table-cell>
              <fo:table-cell>
                <fo:block text-indent="10px">
                  <xsl:value-of select="@price"/>
                </fo:block>
              </fo:table-cell>
            </fo:table-row>

            <fo:table-row>
              <fo:table-cell>
                <fo:block text-align="right">Order no:</fo:block>
              </fo:table-cell>
              <fo:table-cell>
                <fo:block text-indent="10px">
                  <xsl:value-of select="@id"/>
                </fo:block>
              </fo:table-cell>
            </fo:table-row>
          </fo:table-body>
        </fo:table>

      </fo:flow>
    </fo:page-sequence>
  </xsl:template>

  <xsl:template match="para">
    <fo:block space-after="10px">
      <xsl:value-of select="."/>
    </fo:block>
  </xsl:template>

</xsl:stylesheet>
