package dom;

import java.io.IOException;

import org.jdom2.Element;
import org.jdom2.Text;
import org.jdom2.output.Format;
import org.jdom2.output.XMLOutputter;

/**
 * An extension to example {@link CreateDoc}
 * 
 * @author goik
 */
public class CreateExtended {
  /**
   * @param argv Unused cmd argset
   * @throws IOException File acces problem or corrupt content.
   */
  public static void main(String[] argv) throws IOException {
     
     final Element titel = new Element("titel"),
           tLong = new Element("long"),
           tShort = new Element("short");
     
     // Append <long> and <short> to parent <title>
     titel.addContent(tLong).addContent(tShort);
     
     // Append text to <long> and <short>
     tLong.addContent(new Text("The long version of this title"));
     tShort.addContent(new Text("Short version"));
     
     // Set formatting for the XML output
     Format outFormat = Format.getPrettyFormat();
     
     // Serialize to console
     final XMLOutputter printer = new XMLOutputter(outFormat);
     printer.output(titel, System.out);
  }
}