package sax.mixed;

import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

/** Parser, content- and errorhandler assembly */
public class MixedCount {
  /**
   * @throws SAXException Parsing may fail.
   * @throws ParserConfigurationException Unable to instantiate parser.
   */
  public MixedCount()
   throws SAXException, ParserConfigurationException{
      final SAXParserFactory saxPf = SAXParserFactory.newInstance();
      final SAXParser saxParser = saxPf.newSAXParser();
      xmlReader = saxParser.getXMLReader();
      xmlReader.setContentHandler(eventHandler);
      xmlReader.setErrorHandler(errorHandler);
  }
  /** @see sax.stat.v1.ElementCount
   * @param uri The resource to be parsed
   * @throws IOException Access related problems
   * @throws SAXException Parsing may fail
   */
  public void parse(final String uri) 
    throws IOException, SAXException{
    xmlReader.parse(uri);
  }
  /**
   * @return See {@link sax.stat.v1.ElementCount#getElementCount()}
   */
  public int getElementCount() {
    return eventHandler.getMixedElementCount();
  }
  private final XMLReader xmlReader;
  private final MixedCountHandler eventHandler = new MixedCountHandler();
  private final MyErrorHandler errorHandler = new MyErrorHandler();
}