package sax.stat.v1;

import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.SAXParser;

/** Assemble parser, error- and contenthandler */
public class ElementCount {
  /** @param uri The document being operated on */
  public void parse(final String uri) {
    try {
      final SAXParserFactory saxPf = SAXParserFactory.newInstance();
      final SAXParser saxParser = saxPf.newSAXParser();
      saxParser.parse(uri, eventHandler);
    } catch (org.xml.sax.SAXException e) {      
      e.printStackTrace(System.err);
    } catch (ParserConfigurationException e){
      e.printStackTrace(System.err);
    } catch (IOException e){
      e.printStackTrace(System.err);
    }
  }
  /** @return Delegation to @see MyEventHandler#getElementCount() */
  public int getElementCount() {
    return eventHandler.getElementCount();
  }
  private final MyEventHandler eventHandler = new MyEventHandler();
}