package sda.jdbc.intro.v1;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;

public class SimpleInsert {
   
   public static void main(String[] args) throws SQLException {
      
      // Step 1: Open a connection to the database server
      final Connection conn = DriverManager.getConnection (
            DbProps.getString("PersistenceHandler.jdbcUrl"),  
            DbProps.getString("PersistenceHandler.username"),
            DbProps.getString("PersistenceHandler.password"));
      
      // Step 2: Create a PreparedStatement instance
      final PreparedStatement pStmt = conn.prepareStatement("INSERT INTO Person VALUES(?, ?)");
      
      // Step 3a: Fill in desired attribute values
      pStmt.setString(1, "Jim");
      pStmt.setString(2, "jim@foo.org");
      
      // Step 3b: Execute the desired INSERT
      final int updateCount = pStmt.executeUpdate();
      
      // Step 4: Give feedback to the enduser
      System.out.println("Successfully inserted " + updateCount + " dataset(s)"); 
   }
}