package party;

/**
 * According to {@link PartyStatistics#getAverageExpenses()} a party's
 * costs will be shared by the organizers and thus divided by their respective
 * number. If the number of organizers is zero this exception
 * will be thrown on invocation of {@link PartyStatistics#getAverageExpenses()}.
 *
 */
public class NoOrganizerException extends ArithmeticException {
	
	/**
	 * A party having no organizer is likely to fail.
	 * @param expenses Expenses made so far.
	 */
	public NoOrganizerException(float expenses) {
		super("No organizer has been defined. How shall I share " + expenses + " of expenses?");
	}
}
