package party2;

import party.NoOrganizerException;
import party.PartyStatistics;

/**
 * Implementing party statistics.
 *
 */
public class PartyStatisticsImpl implements PartyStatistics {
    
    @Override
    public void setNumberOfGuests(int numGuests) { this.numGuests = numGuests;}

    @Override
    public void setNumberOfOrganizers(int numOrganizers) { this.numOrganizers = numOrganizers;}

    @Override
    public void setExpenses(float expenses) { this.expenses = expenses;}

    @Override
    public float getAverageExpenses() throws NoOrganizerException {
        if (0 < numOrganizers) {
            return expenses / numOrganizers;
        } else {
            throw new NoOrganizerException(expenses);
        }
    }
    @Override
    public int getNumberOfHandshakes() {
        final int totalPersonsNum = numGuests + numOrganizers;
        return totalPersonsNum * (totalPersonsNum - 1) / 2;
    }
    
    int numGuests = 0; // Just for setter definition.
    int numOrganizers = 0;
    float expenses = 0f;
}
