package xml2rdbms.solution;

import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;


/**
 * Processing XML input data.
 *
 */
public class XmlDriver {

	/**
	 * Reading XML input from src/xml2rdbms/data.xml and processing
	 * by {@link BillingHandler}.
	 * @param args unused.
	 */
	public static void main(String[] args) {
		
		final BillingHandler billingHandler = new BillingHandler();
		
		try {
		      final SAXParserFactory saxPf = SAXParserFactory.newInstance();
		      final SAXParser saxParser = saxPf.newSAXParser();
		      saxParser.parse("src/xml2rdbms/data.xml", billingHandler);
		    } catch (ParserConfigurationException e){
		      e.printStackTrace(System.err);
		    } catch (org.xml.sax.SAXException e) {
		      e.printStackTrace(System.err);
		    } catch (IOException e){
		      e.printStackTrace(System.err);
		    }
	}

}
