package hdm.utils.xmlparse;

import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import org.xml.sax.EntityResolver;
import org.xml.sax.InputSource;
import org.xml.sax.helpers.DefaultHandler;

public class ParserHandler extends  DefaultHandler implements EntityResolver {
  public ParserHandler(){
  }     
  public InputSource resolveEntity (String pubId, String sysId){
    publicId = pubId;
    systemId = sysId;
    if (null != systemId || null != pubId){
      StringBuffer log = new StringBuffer("Parsing ");
      if (null != systemId &&
          0 != systemId.trim().length()){
        log.append("system id=\"");
        log.append(systemId);
        log.append("\"");
      }
      if (null != publicId &&
          0 != publicId.trim().length()){
        log.append(" public id=\"");
        log.append(publicId);
        log.append("\"\n");
      }
      logBuffer.append(log);
    }
    return null;
  }
  public String getLogMessages(){
    return logBuffer.toString();
  }
  public static String getLastId(){
    String res = "recently parsed unit:";
    if (null != publicId){
      res += " public ID was " + publicId;
    }
    if (null != systemId){
      res += " system ID was " + systemId;
    }
    return res;
  }
  public void warning(SAXParseException e) throws SAXException {
    printError("warning", e);
  }
  public void error(SAXParseException e) throws SAXException {
    printError("parse error", e);
  }
  public void fatalError(SAXParseException e) throws SAXException {
    printError("fatal error", e);
    throw e;
  }
  private void printError(final String messageType, SAXParseException e) 
    throws SAXException {
    System.err.println
       (e.getSystemId() + ":" + e.getLineNumber() + 
        ":" + e.getColumnNumber() + 
        ": " + messageType + 
        " " + e);
    throw e;
  }

  private StringBuffer logBuffer = new StringBuffer();
  private static String publicId = null;
  private static String systemId = null;
}
 
